org.apache.solr.common.params

## Interface FacetParams

    public interface FacetParams

Facet parameters

### Nested Class Summary

Nested Classes

`static class`

`FacetParams.FacetRangeInclude`
An enumeration of the legal values for `FACET_DATE_INCLUDE` and `FACET_RANGE_INCLUDE`
lower = all gap based ranges include their lower bound upper = all gap based ranges include their upper bound edge = the first and last gap ranges include their edge bounds (ie: lower for the first one, upper for the last one) even if the corresponding upper/lower option is not specified outer = the BEFORE and AFTER ranges should be inclusive of their bounds, even if the first or last ranges already include those boundaries.

`static class` `FacetParams.FacetRangeMethod` An enumeration of the legal values for `FACET_RANGE_METHOD` filter = dv =
`static class` `FacetParams.FacetRangeOther` An enumeration of the legal values for `FACET_RANGE_OTHER` and `FACET_DATE_OTHER` ...

### Field Summary

Fields
`static String` `FACET` Should facet counts be calculated?
`static String` `FACET_CONTAINS` Only return constraints of a facet field containing the given string.
`static String` `FACET_CONTAINS_IGNORE_CASE` If using facet contains, ignore case when comparing values.
`static String` `FACET_DATE` Any field whose terms the user wants to enumerate over for Facet Contraint Counts (multi-value)
`static String` `FACET_DATE_END` Date string indicating the ending point for a date facet range.
`static String` `FACET_DATE_GAP` Date Math string indicating the interval of sub-ranges for a date facet range.
`static String` `FACET_DATE_HARD_END` Boolean indicating how counts should be computed if the range between 'start' and 'end' is not evenly divisible by 'gap'.
`static String` `FACET_DATE_INCLUDE` Multivalued string indicating what rules should be applied to determine when the the ranges generated for date faceting should be inclusive or exclusive of their end points.
`static String` `FACET_DATE_OTHER` String indicating what "other" ranges should be computed for a date facet range (multi-value).
`static String` `FACET_DATE_START` Date string indicating the starting point for a date facet range.
`static String` `FACET_ENUM_CACHE_MINDF` When faceting by enumerating the terms in a field, only use the filterCache for terms with a df >= to this parameter.
`static String` `FACET_FIELD` Any field whose terms the user wants to enumerate over for Facet Constraint Counts (multi-value)
`static String` `FACET_HEATMAP` A spatial RPT field to generate a 2D "heatmap" (grid of facet counts) on.
`static String` `FACET_HEATMAP_DIST_ERR` Used to determine the heatmap grid level to compute (optional).
`static String` `FACET_HEATMAP_DIST_ERR_PCT` Used to determine the heatmap grid level to compute, defaulting to 0.15.
`static String` `FACET_HEATMAP_FORMAT` The format of the heatmap: either png or ints2D (default).
`static String` `FACET_HEATMAP_GEOM` The region the heatmap should minimally enclose.
`static String` `FACET_HEATMAP_LEVEL` Specify the heatmap grid level explicitly, instead of deriving it via distErr or distErrPct.
`static String` `FACET_HEATMAP_MAX_CELLS` The maximum number of cells (grid squares) the client is willing to handle.
`static String` `FACET_INTERVAL` Any field whose values the user wants to enumerate as explicit intervals of terms.
`static String` `FACET_INTERVAL_SET` Set of terms for a single interval to facet on.
`static String` `FACET_LIMIT` Numeric option indicating the maximum number of facet field counts be included in the response for each field - in descending order of count.
`static String` `FACET_METHOD` What method should be used to do the faceting
`static String` `FACET_METHOD_enum` Value for FACET_METHOD param to indicate that Solr should enumerate over terms in a field to calculate the facet counts.
`static String` `FACET_METHOD_fc` Value for FACET_METHOD param to indicate that Solr should enumerate over documents and count up terms by consulting an uninverted representation of the field values (such as the FieldCache used for sorting).
`static String` `FACET_METHOD_fcs` Value for FACET_METHOD param, like FACET_METHOD_fc but counts per-segment.
`static String` `FACET_MINCOUNT` Numeric option indicating the minimum number of hits before a facet should be included in the response.
`static String` `FACET_MISSING` Boolean option indicating whether the response should include a facet field count for all records which have no value for the facet field.
`static String` `FACET_OFFSET` The offset into the list of facets.
`static String` `FACET_OVERREQUEST`
`static String` `FACET_OVERREQUEST_COUNT` An additional amount to over-request by when performing initial distributed requests.
`static String` `FACET_OVERREQUEST_RATIO` The percentage to over-request by when performing initial distributed requests.
`static String` `FACET_PIVOT` Comma separated list of fields to pivot example: author,type (for types by author / types within author)
`static String` `FACET_PIVOT_MINCOUNT` Minimum number of docs that need to match to be included in the sublist default value is 1
`static String` `FACET_PREFIX` Only return constraints of a facet field with the given prefix.
`static String` `FACET_QUERY` Any lucene formated queries the user would like to use for Facet Constraint Counts (multi-value)
`static String` `FACET_RANGE` Any numerical field whose terms the user wants to enumerate over Facet Contraint Counts for selected ranges.
`static String` `FACET_RANGE_END` Number indicating the ending point for a numerical range facet.
`static String` `FACET_RANGE_GAP` Number indicating the interval of sub-ranges for a numerical facet range.
`static String` `FACET_RANGE_HARD_END` Boolean indicating how counts should be computed if the range between 'start' and 'end' is not evenly divisible by 'gap'.
`static String` `FACET_RANGE_INCLUDE` Multivalued string indicating what rules should be applied to determine when the the ranges generated for numeric faceting should be inclusive or exclusive of their end points.
`static String` `FACET_RANGE_METHOD` String indicating the method to use to resolve range facets.
`static String` `FACET_RANGE_OTHER` String indicating what "other" ranges should be computed for a numerical range facet (multi-value).
`static String` `FACET_RANGE_START` Number indicating the starting point for a numerical range facet.
`static String` `FACET_SORT` String option: "count" causes facets to be sorted by the count, "index" results in index order.
`static String` `FACET_SORT_COUNT`
`static String` `FACET_SORT_COUNT_LEGACY`
`static String` `FACET_SORT_INDEX`
`static String` `FACET_SORT_INDEX_LEGACY`
`static String` `FACET_THREADS` Numeric option indicating the maximum number of threads to be used in counting facet field vales
`static String` `FACET_ZEROS` Boolean option indicating whether facet field counts of "0" should be included in the response.

### Field Detail

#### FACET

    static final String FACET

Should facet counts be calculated?

See Also:
  Constant Field Values

#### FACET_THREADS

    static final String FACET_THREADS

Numeric option indicating the maximum number of threads to be used in counting facet field vales

See Also:
  Constant Field Values

#### FACET_METHOD

    static final String FACET_METHOD

What method should be used to do the faceting

See Also:
  Constant Field Values

#### FACET_METHOD_enum

    static final String FACET_METHOD_enum

Value for FACET_METHOD param to indicate that Solr should enumerate over terms in a field to calculate the facet counts.

See Also:
  Constant Field Values

#### FACET_METHOD_fc

    static final String FACET_METHOD_fc

Value for FACET_METHOD param to indicate that Solr should enumerate over documents and count up terms by consulting an uninverted representation of the field values (such as the FieldCache used for sorting).

See Also:
  Constant Field Values

#### FACET_METHOD_fcs

    static final String FACET_METHOD_fcs

Value for FACET_METHOD param, like FACET_METHOD_fc but counts per-segment.

See Also:
  Constant Field Values

#### FACET_QUERY

    static final String FACET_QUERY

Any lucene formated queries the user would like to use for Facet Constraint Counts (multi-value)

See Also:
  Constant Field Values

#### FACET_FIELD

    static final String FACET_FIELD

Any field whose terms the user wants to enumerate over for Facet Constraint Counts (multi-value)

See Also:
  Constant Field Values

#### FACET_OFFSET

    static final String FACET_OFFSET

The offset into the list of facets. Can be overridden on a per field basis.

See Also:
  Constant Field Values

#### FACET_LIMIT

    static final String FACET_LIMIT

Numeric option indicating the maximum number of facet field counts be included in the response for each field - in descending order of count. Can be overridden on a per field basis.

See Also:
  Constant Field Values

#### FACET_MINCOUNT

    static final String FACET_MINCOUNT

Numeric option indicating the minimum number of hits before a facet should be included in the response. Can be overridden on a per field basis.

See Also:
  Constant Field Values

#### FACET_ZEROS

    static final String FACET_ZEROS

Boolean option indicating whether facet field counts of "0" should be included in the response. Can be overridden on a per field basis.

See Also:
  Constant Field Values

#### FACET_MISSING

    static final String FACET_MISSING

Boolean option indicating whether the response should include a facet field count for all records which have no value for the facet field. Can be overridden on a per field basis.

See Also:
  Constant Field Values

#### FACET_OVERREQUEST

    static final String FACET_OVERREQUEST

See Also:
  Constant Field Values

#### FACET_OVERREQUEST_RATIO

    static final String FACET_OVERREQUEST_RATIO

The percentage to over-request by when performing initial distributed requests. default value is 1.5

See Also:
  Constant Field Values

#### FACET_OVERREQUEST_COUNT

    static final String FACET_OVERREQUEST_COUNT

An additional amount to over-request by when performing initial distributed requests. This value will be added after accounting for the over-request ratio. default value is 10

See Also:
  Constant Field Values

#### FACET_PIVOT

    static final String FACET_PIVOT

Comma separated list of fields to pivot example: author,type (for types by author / types within author)

See Also:
  Constant Field Values

#### FACET_PIVOT_MINCOUNT

    static final String FACET_PIVOT_MINCOUNT

Minimum number of docs that need to match to be included in the sublist default value is 1

See Also:
  Constant Field Values

#### FACET_SORT

    static final String FACET_SORT

String option: "count" causes facets to be sorted by the count, "index" results in index order.

See Also:
  Constant Field Values

#### FACET_SORT_COUNT

    static final String FACET_SORT_COUNT

See Also:
  Constant Field Values

#### FACET_SORT_COUNT_LEGACY

    static final String FACET_SORT_COUNT_LEGACY

See Also:
  Constant Field Values

#### FACET_SORT_INDEX

    static final String FACET_SORT_INDEX

See Also:
  Constant Field Values

#### FACET_SORT_INDEX_LEGACY

    static final String FACET_SORT_INDEX_LEGACY

See Also:
  Constant Field Values

#### FACET_PREFIX

    static final String FACET_PREFIX

Only return constraints of a facet field with the given prefix.

See Also:
  Constant Field Values

#### FACET_CONTAINS

    static final String FACET_CONTAINS

Only return constraints of a facet field containing the given string.

See Also:
  Constant Field Values

#### FACET_CONTAINS_IGNORE_CASE

    static final String FACET_CONTAINS_IGNORE_CASE

If using facet contains, ignore case when comparing values.

See Also:
  Constant Field Values

#### FACET_ENUM_CACHE_MINDF

    static final String FACET_ENUM_CACHE_MINDF

When faceting by enumerating the terms in a field, only use the filterCache for terms with a df >= to this parameter.

See Also:
  Constant Field Values

#### FACET_DATE

    static final String FACET_DATE

Any field whose terms the user wants to enumerate over for Facet Contraint Counts (multi-value)

See Also:
  Constant Field Values

#### FACET_DATE_START

    static final String FACET_DATE_START

Date string indicating the starting point for a date facet range. Can be overriden on a per field basis.

See Also:
  Constant Field Values

#### FACET_DATE_END

    static final String FACET_DATE_END

Date string indicating the ending point for a date facet range. Can be overriden on a per field basis.

See Also:
  Constant Field Values

#### FACET_DATE_GAP

    static final String FACET_DATE_GAP

Date Math string indicating the interval of sub-ranges for a date facet range. Can be overriden on a per field basis.

See Also:
  Constant Field Values

#### FACET_DATE_HARD_END

    static final String FACET_DATE_HARD_END

Boolean indicating how counts should be computed if the range between 'start' and 'end' is not evenly divisible by 'gap'. If this value is true, then all counts of ranges involving the 'end' point will use the exact endpoint specified -- this includes the 'between' and 'after' counts as well as the last range computed using the 'gap'. If the value is false, then 'gap' is used to compute the effective endpoint closest to the 'end' param which results in the range between 'start' and 'end' being evenly divisible by 'gap'. The default is false. Can be overriden on a per field basis.

See Also:
  Constant Field Values

#### FACET_DATE_OTHER

    static final String FACET_DATE_OTHER

String indicating what "other" ranges should be computed for a date facet range (multi-value). Can be overriden on a per field basis.

See Also:
  `FacetParams.FacetRangeOther`, Constant Field Values

#### FACET_DATE_INCLUDE

    static final String FACET_DATE_INCLUDE

Multivalued string indicating what rules should be applied to determine when the the ranges generated for date faceting should be inclusive or exclusive of their end points.

The default value if none are specified is: [lower,upper,edge] (NOTE: This is different then FACET_RANGE_INCLUDE)

Can be overriden on a per field basis.

See Also:
  `FacetParams.FacetRangeInclude`, `FACET_RANGE_INCLUDE`, Constant Field Values

#### FACET_RANGE

    static final String FACET_RANGE

Any numerical field whose terms the user wants to enumerate over Facet Contraint Counts for selected ranges.

See Also:
  Constant Field Values

#### FACET_RANGE_START

    static final String FACET_RANGE_START

Number indicating the starting point for a numerical range facet. Can be overriden on a per field basis.

See Also:
  Constant Field Values

#### FACET_RANGE_END

    static final String FACET_RANGE_END

Number indicating the ending point for a numerical range facet. Can be overriden on a per field basis.

See Also:
  Constant Field Values

#### FACET_RANGE_GAP

    static final String FACET_RANGE_GAP

Number indicating the interval of sub-ranges for a numerical facet range. Can be overriden on a per field basis.

See Also:
  Constant Field Values

#### FACET_RANGE_HARD_END

    static final String FACET_RANGE_HARD_END

Boolean indicating how counts should be computed if the range between 'start' and 'end' is not evenly divisible by 'gap'. If this value is true, then all counts of ranges involving the 'end' point will use the exact endpoint specified -- this includes the 'between' and 'after' counts as well as the last range computed using the 'gap'. If the value is false, then 'gap' is used to compute the effective endpoint closest to the 'end' param which results in the range between 'start' and 'end' being evenly divisible by 'gap'. The default is false. Can be overriden on a per field basis.

See Also:
  Constant Field Values

#### FACET_RANGE_OTHER

    static final String FACET_RANGE_OTHER

String indicating what "other" ranges should be computed for a numerical range facet (multi-value). Can be overriden on a per field basis.

See Also:
  Constant Field Values

#### FACET_RANGE_INCLUDE

    static final String FACET_RANGE_INCLUDE

Multivalued string indicating what rules should be applied to determine when the the ranges generated for numeric faceting should be inclusive or exclusive of their end points.

The default value if none are specified is: lower

Can be overriden on a per field basis.

See Also:
  `FacetParams.FacetRangeInclude`, Constant Field Values

#### FACET_RANGE_METHOD

    static final String FACET_RANGE_METHOD

String indicating the method to use to resolve range facets.

Can be overriden on a per field basis.

See Also:
  `FacetParams.FacetRangeMethod`, Constant Field Values

#### FACET_INTERVAL

    static final String FACET_INTERVAL

Any field whose values the user wants to enumerate as explicit intervals of terms.

See Also:
  Constant Field Values

#### FACET_INTERVAL_SET

    static final String FACET_INTERVAL_SET

Set of terms for a single interval to facet on.

See Also:
  Constant Field Values

#### FACET_HEATMAP

    static final String FACET_HEATMAP

A spatial RPT field to generate a 2D "heatmap" (grid of facet counts) on. Just like the other faceting types, this may include a 'key' or local-params to facet multiple times. All parameters with this suffix can be overridden on a per-field basis.

See Also:
  Constant Field Values

#### FACET_HEATMAP_FORMAT

    static final String FACET_HEATMAP_FORMAT

The format of the heatmap: either png or ints2D (default).

See Also:
  Constant Field Values

#### FACET_HEATMAP_GEOM

    static final String FACET_HEATMAP_GEOM

The region the heatmap should minimally enclose. It defaults to the world if not set. The format can either be a minimum to maximum point range format:

    ["-150 10" TO "-100 30"]

(the first is bottom-left and second is bottom-right, both of which are parsed as points are parsed). OR, any WKT can be provided and it's bounding box will be taken.

See Also:
  Constant Field Values

#### FACET_HEATMAP_LEVEL

    static final String FACET_HEATMAP_LEVEL

Specify the heatmap grid level explicitly, instead of deriving it via distErr or distErrPct.

See Also:
  Constant Field Values

#### FACET_HEATMAP_DIST_ERR_PCT

    static final String FACET_HEATMAP_DIST_ERR_PCT

Used to determine the heatmap grid level to compute, defaulting to 0.15. It has the same interpretation of distErrPct when searching on RPT, but relative to the shape in 'bbox'. It's a fraction (not a %) of the radius of the shape that grid squares must fit into without exceeding. > 0 and <= 0.5. Mutually exclusive with distErr & gridLevel.

See Also:
  Constant Field Values

#### FACET_HEATMAP_DIST_ERR

    static final String FACET_HEATMAP_DIST_ERR

Used to determine the heatmap grid level to compute (optional). It has the same interpretation of maxDistErr or distErr with RPT. It's an absolute distance (in units of what's specified on the field type) that a grid square must maximally fit into (width & height). It can be used to to more explicitly specify the maximum grid square size without knowledge of what particular grid levels translate to. This can in turn be used with knowledge of the size of 'bbox' to get a target minimum number of grid cells. Mutually exclusive with distErrPct & gridLevel.

See Also:
  Constant Field Values

#### FACET_HEATMAP_MAX_CELLS

    static final String FACET_HEATMAP_MAX_CELLS

The maximum number of cells (grid squares) the client is willing to handle. If this limit would be exceeded, we throw an error instead. Defaults to 100k.

See Also:
  Constant Field Values